<?php
/*
	Attachments Gallery
	Display attachments gallery from specified forum(s)
	Adapted by LeeFish from a plug in by RateU at MyBBHacks.
	The author doesn't have responsibility for any harm to your forum that could have been caused by this plugin/mod.
	Use at your own risk.
*/

if(!defined('IN_MYBB'))
{
	die('Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.');
}

function fishhattatgal_info()
{
	return array(
		'name'			=> 'Fresh Fish Attachments Gallery',
		'description'	=> 'Fresh Fish Attachments Gallery',
		'website'		=> 'http://www.leefish.nl/mybb/forum-51.html',
		'author'		=> 'RateU',
		'authorsite'	=> 'http://mybbhacks.zingaburga.com/member.php?action=profile&uid=171',
		'version'		=> '1.1',
		'compatibility' => '1*',
	);
}

function fishhattatgal_activate()
{
	global $db;
	
	$settinggroups = array(
		'name'			=> 'fishhattatgal_title',
		'title'			=> 'Fresh Fish Attachments Gallery',
		'description'	=> 'Settings For Fresh Fish Attachments Gallery',
		'disporder'		=> '99',// My Favorite Number :)
		'isdefault'		=> 'no'
	);
	
	$db->insert_query('settinggroups',$settinggroups);
	$gid = $db->insert_id();
	
	$settings = array(
		'name'			=> 'fishhattatgal_ed',
		'title'			=> 'Enable/Disable',
		'description'	=> 'Do you want to enable The Fresh Fish Attachments Gallery?',
		'optionscode'	=> 'yesno',
		'value'			=> '1',
		'disporder'		=> '1',
		'gid'			=> intval($gid)
	);
	$db->insert_query("settings",$settings);

	$settings = array(
		'name'			=> 'fishhattatgal_fid',
		'title'			=> 'Forum ID',
		'description'	=> 'Type the forum id(s) for the Fresh Fish Attachments Gallery. Seperate with commas.',
		'optionscode'	=> 'text',
		'value'			=> '2,3',
		'disporder'		=> '2',
		'gid'			=> intval($gid)
	);
	$db->insert_query("settings",$settings);

	$settings = array(
		'name'			=> 'fishhattatgal_num',
		'title'			=> 'Number Of Attachments Thumbnails',
		'description'	=> 'How many attachments thumbnails do you want to be displayed?',
		'optionscode'	=> 'text',
		'value'			=> '5',
		'disporder'		=> '3',
		'gid'			=> intval($gid)
	);
	$db->insert_query("settings",$settings);
	
	$settings = array(
		'name'			=> 'fishhattatgal_dsp',
		'title'			=> 'Displaying Fresh Fish Attachments Gallery',
		'description'	=> 'Where do you want the Fresh Fish Attachments Gallery to be displayed?',
		'optionscode'	=> 'select
portal=Portal
index=Index
poin=Portal And Index
global=All Pages',
		'value'			=> 'portal',
		'disporder'		=> '4',
		'gid'			=> intval($gid)
	);
	$db->insert_query("settings",$settings);

	$template = array(
		'tid'		=> NULL,
		'title'		=> "fishhatt_gallery",
		'template'	=> "<table border=\"0\" cellspacing=\"{\$theme[\'borderwidth\']}\" cellpadding=\"{\$theme[\'tablespace\']}\" class=\"tborder\">
	<tbody>
		<tr>
			<td class=\"thead\">
				<div class=\"expcolimage\">
					<img src=\"{\$theme[\'imgdir\']}/collapse{\$collapsedimg[\'fishhattatgal\']}.gif\" id=\"fishhattatgal_img\" class=\"expander\" alt=\"[-]\" title=\"\" />
				</div>
				<div><strong>Attachments Gallery</strong></div>
			</td>
		</tr>
	</tbody>
	<tbody style=\"{\$collapsed[\'fishhattatgal_e\']}\" id=\"fishhattatgal_e\">
		<tr>
			<td class=\"trow1\" align=\"center\">
				{\$fishhatt_gallery_gallery}
			</td>
		</tr>
	</tbody>
</table>
<br />",
		'sid'		=> "-1"
	);
	
	$db->insert_query("templates", $template);
	
	$template = array(
		'tid'		=> NULL,
		'title'		=> "fishhatt_gallery_gallery",
		'template'	=> "<a href=\"{\$fishhatt_postlink}\"><img src=\"{\$fishhatt_att_thumb}\" alt=\"{\$fishhatt_title}\" title=\"{\$fishhatt_title}, Posted By: {\$fishhatt_username} Uploaded At: {\$fishhatt_datetime}\" class=\"attachment\" style=\"vertical-align: middle\" /></a>",
		'sid'		=> "-1"
	);
	$db->insert_query("templates", $template);
	rebuild_settings();
	
	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	find_replace_templatesets('header', '#^(.*)$#s', "\\1\r\n" . '<!-- Attachment Gallery -->');
}

function fishhattatgal_deactivate()
{
	global $db;

	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='fishhatt_gallery'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='fishhatt_gallery_gallery'");
	$db->query('DELETE FROM '.TABLE_PREFIX.'settinggroups WHERE name=\'fishhattatgal_title\'');
	$db->query('DELETE FROM '.TABLE_PREFIX.'settings WHERE name IN(
		\'fishhattatgal_ed\',
		\'fishhattatgal_fid\',
		\'fishhattatgal_num\',
		\'fishhattatgal_dsp\'
	)');
	rebuild_settings();
	
	require MYBB_ROOT.'/inc/adminfunctions_templates.php';
	find_replace_templatesets('header', '#<!-- Attachment Gallery -->#', '', 0);
}

$plugins->add_hook('global_start', 'fishhattatgal_tcache');
function fishhattatgal_tcache()
{
	if(isset($GLOBALS['templatelist']))
	{
		$GLOBALS['templatelist'] .= ',fishhatt_gallery,fishhatt_gallery_gallery';
	}

	if($GLOBALS['mybb']->settings['fishhattatgal_dsp'] == 'portal')
	{
		$GLOBALS['plugins']->add_hook('portal_start', 'fishhattatgal_run');
	}
	elseif($GLOBALS['mybb']->settings['fishhattatgal_dsp'] == 'index')
	{
		$GLOBALS['plugins']->add_hook('index_end', 'fishhattatgal_run');
	}
	elseif($GLOBALS['mybb']->settings['fishhattatgal_dsp'] == 'poin')
	{
		$GLOBALS['plugins']->add_hook('index_end', 'fishhattatgal_run');
		$GLOBALS['plugins']->add_hook('portal_start', 'fishhattatgal_run');
	}
	else
	{
		$GLOBALS['plugins']->add_hook('global_end', 'fishhattatgal_run');
	}
}

function fishhattatgal_run()
{
    global $mybb, $db, $collapsed, $collapsedimg, $templates, $theme, $fishhattachment_gallery;
	if($mybb->settings['fishhattatgal_ed'] != 0)
	{
		$fishhattatgal_num = intval($mybb->settings['fishhattatgal_num']);
		if(is_array(explode(',', $mybb->settings['fishhattatgal_fid'])))
		{
			foreach(explode(',', $mybb->settings['fishhattatgal_fid']) as $fishhattatgal_tid)
			{
				$fishhattatgal_tid_array[] = intval($fishhattatgal_tid);
			}
		}
			$query = $db->query("
			SELECT a.updatetime, a.md5hash, a.uploadtime, a.aid, a.attachname, a.filename, a.thumbs, a.field, t.*
			FROM ".TABLE_PREFIX."xtattachments a
			LEFT JOIN ".TABLE_PREFIX."threads t ON (t.tid=a.tid)
			WHERE t.visible=1 AND a.thumbs!=' ' AND t.closed NOT LIKE 'moved|%' AND t.fid IN ('".implode("','", $fishhattatgal_tid_array)."')
			GROUP BY t.tid
			ORDER BY t.views DESC
			LIMIT $fishhattatgal_num
		");
		
		while($fishhatt = $db->fetch_array($query))
		{
			$fishhatt_username = htmlspecialchars_uni($fishhatt['username']);
			$fishhatt_views = number_format($fishhatt['views']);
			$fishhatt_replies = number_format($fishhatt['replies']);
			$fishhatt_title = htmlspecialchars_uni($fishhatt['subject']);
			$fishhatt_postlink = get_thread_link(intval($fishhatt['tid']));
			$fishhatt_datetime = my_date($mybb->settings['dateformat'], $fishhatt['uploadtime']).' '.my_date($mybb->settings['timeformat'], $fishhatt['uploadtime']);
			$fishhatt_att_thumb = xthreads_get_xta_url($fishhatt).'/thumb160x120';
			eval("\$fishhatt_gallery_gallery .= \"".$templates->get("fishhatt_gallery_gallery")."\";");
		}
		eval("\$fishhattachment_gallery = \"".$templates->get("fishhatt_gallery")."\";");
	}
}
?>